import java.io.*;

import org.xml.sax.*;
import org.xml.sax.helpers.AttributesImpl;

public class NodeDataReader
	implements XMLReader
{
	ContentHandler handler;
	// We're not doing namespaces, and we have no
	// attributes on our elements.
	String nsu = ""; // NamespaceURI
	Attributes atts = new AttributesImpl();
	String rootElement = "nodedata";
	String indent = "\n "; // for readability!

/** Parse the input */
public void parse(InputSource input)
{
	try
	{
		// Get an efficient reader for the file
		java.io.Reader r = input.getCharacterStream();

		BufferedReader br = new BufferedReader(r);
		// Read the file and display its contents.
		String line = null;

		while (null != (line = br.readLine()))
		{
			if (line.startsWith("Contact: "))
			break;
		}

		if (handler == null) {
		throw new SAXException("No content handler");
		}
		handler.startDocument();
		handler.startElement(nsu, rootElement, rootElement, atts);

		output("contact", "Contact", line);
		line = br.readLine();

		output("email", "Email", line);
		line = br.readLine();

		output("telephone", "Phone", line);
		line = br.readLine();

		output("sysnname","System name", line);
		line = br.readLine();

		output("IP-capable", "IP-capable", line);
		line = br.readLine();

		output("MPLS-capable", "MPLS-capable", line);
		line = br.readLine();

		output("Last Discovery", "Last Discovery", line);
		line = br.readLine();

		output("Location", "Location", line);

		handler.ignorableWhitespace("\n".toCharArray(),
		0, // start index
		1 // length
		);

		handler.endElement(nsu, rootElement, rootElement);
		handler.endDocument();
	}

	catch (Exception e)
	{
		e.printStackTrace();
	}
}

void output(String name, String prefix, String line)
	throws SAXException
{
	int startIndex = prefix.length() + 2;
	// 2=length of ": "
	String text = line.substring(startIndex);
	int textLength = line.length() - startIndex;
	handler.ignorableWhitespace(indent.toCharArray(),
	0, // start index
	indent.length());
	handler.startElement(nsu, name, name /*"qName"*/, atts);
	handler.characters(line.toCharArray(),
	startIndex,
	textLength);
	handler.endElement(nsu, name, name);
}

/** Allow an application to register a content event handler. */
public void setContentHandler(ContentHandler handler)
{
	this.handler = handler;
}

/** Return the current content handler. */
public ContentHandler getContentHandler()
{
	return this.handler;
}

/** Allow an application to register an error event handler. */
public void setErrorHandler(ErrorHandler handler)
{ }

/** Return the current error handler. */
public ErrorHandler getErrorHandler()
{ return null; }

/** Parse an XML document from a system identifier (URI). */
public void parse(String systemId)
throws IOException, SAXException
{ }

/** Return the current DTD handler. */
public DTDHandler getDTDHandler()
{ return null; }

/** Return the current entity resolver. */
public EntityResolver getEntityResolver()
{ return null; }

/** Allow an application to register an entity resolver. */
public void setEntityResolver(EntityResolver resolver)
{ }

/** Allow an application to register a DTD event handler. */
public void setDTDHandler(DTDHandler handler)
{ }

/** Look up the value of a property. */
public Object getProperty(String name)
{ return null; }

/** Set the value of a property. */
public void setProperty(String name, Object value)
{ }

/** Set the state of a feature. */
public void setFeature(String name, boolean value)
{ }

/** Look up the value of a feature. */
public boolean getFeature(String name)
{ return false; }
}